/*****************************  Globals   *************************************/                 
const nsTiscaliClassID = Components.ID("{eb8a95e0-3f07-11da-8cd6-0800200c9a66}");
const nsTiscaliContactID = "@mozilla.org/TiscaliPOP;1";
const ExtTiscaliGuid = "{f42aaf50-3f07-11da-8cd6-0800200c9a66}";


/******************************  Tiscali ***************************************/

// var sid="991BB478469296A273673F0A72E46952819ADCA0";
const PatternTiscaliSessionID =/.*var sid="(.*)";/;

const PatternTiscaliInboxURL =/.*NavA\(\'(\/mail\/MessageList\?sid=.*)\'\);/;

// const PatternTiscaliMsgIDStep1Table =/<td width=\"194\"><a href=\".*srcfolder=INBOX&uid=(.*)&srch.*/g;
// const PatternTiscaliMsgIDStep2Table =/<td width=\"194\"><a href=\".*srcfolder=INBOX&uid=(.*)&srch.*/;

const PatternTiscaliMsgIDStep1Table =/<input type=\"hidden\" name=\"msg(.*)\" value=/g;
const PatternTiscaliMsgIDStep2Table =/<input type=\"hidden\" name=\"msg(.*)\" value=/;

// <script>TDEv(40);</script>&nbsp;<b>14 Kb</b>&nbsp;</TD>
const PatternTiscaliMsgSizeStep1Table = /<td width=\"60\" nowrap>(.*)<\/td>/g;
const PatternTiscaliMsgSizeStep2Table = /<td width=\"60\" nowrap>(.*)<\/td>/;
const PatternTiscaliMsgSizeStep3Table =/<b>(.*)<\/b>/;

const PatternTiscaliDeleteError = /<center><span class=\"error\">.*/

function nsTiscali()
{
    try
    {       
        var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
        scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
        scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/comms.js");
        scriptLoader.loadSubScript("chrome://tiscali/content/TiscaliMSG.js");


	var date = new Date();
	var  szLogFileName = "TiscaliLog_" + date.getHours()+ "_" + date.getMinutes() + "_"+ date.getUTCMilliseconds() +"_";
	// var  szLogFileName = "TiscaliLog_";
	this.m_Log = new DebugLog("webmail.logging.comms", ExtTiscaliGuid, szLogFileName); 

	this.m_Log.Write("nsTiscali.js - Constructor - START");   

	this.m_szMailURL = null;
	this.m_szMailboxURI = null;
        this.m_bAuthorised = false;
        this.m_szUserName = null;
        this.m_szPassWord = null;
        this.m_oResponseStream = null;
        this.m_HttpComms = new Comms(this , this.m_Log); 
        this.m_iStage = 0; 
        this.m_szSessionID = null;

        this.m_aMsgDataStore = new Array();
        this.m_iTotalSize = 0;

	this.m_szMsgID = 0;
        this.m_Log.Write("nsTiscali.js - Constructor - END");  
    }
    catch(e)
    {
        DebugDump("nsTiscali.js: Constructor : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
    }
}



nsTiscali.prototype =
{
    get userName() {return this.m_szUserName;},
    set userName(userName) {return this.m_szUserName = userName;},
  
    get passWord() {return this.m_szPassWord;},
    set passWord(passWord) {return this.m_szPassWord = passWord;},
    
    get bAuthorised() {return this.m_bAuthorised;},
  
    get ResponseStream() {return this.m_oResponseStream;},
    set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},

    logIn : function()
    {
        try
        {
            this.m_Log.Write("nsTiscali.js - logIN - START");   
            this.m_Log.Write("nsTiscali.js - logIN - Username: " + this.m_szUserName 
                                                   + " Password: " + this.m_szPassWord
                                                   + " stream: " + this.m_oResponseStream);

            if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;

		// get starting webPage
		this.m_szMailURL = "http://mail.tiscali.it"
		var mainPageURL = this.m_szMailURL + "/mail/Login?domain=default&style=default&plain=0"

		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(mainPageURL);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.loginOnloadHandler);
		if (!bResult) throw new Error("httpConnection returned false");


            this.m_Log.Write("nsTiscali.js - logIN - END");    
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsTiscali.js: logIN : Exception : " 
                                              + e.name + 
                                              ".\nError message: " 
                                              + e.message);
            return false;
        }
    },


    loginOnloadHandler : function(szResponse ,event , mainObject)
    {
        try
        {
            mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler - START"); 

		mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler : " + mainObject.m_iStage);  

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//if this fails we've gone somewhere new
		mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler - status :" +httpChannel.responseStatus );
		if (httpChannel.responseStatus != 200) 
			throw new Error("return status " + httpChannel.responseStatus);

		mainObject.m_HttpComms.clean();
		mainObject.m_HttpComms.setContentType(0);

		//page code
		switch (mainObject.m_iStage) {
		case 0: // we need to get sessionID first
			var sessionID = szResponse.match(PatternTiscaliSessionID);
			if (sessionID == null)
				throw new Error("error parsing tiscali login web page");

			mainObject.m_szSessionID = sessionID[1];

			mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler - SessionID = " + mainObject.m_szSessionID);

			var szInboxURL = mainObject.m_szMailURL + '/mail/LoginPlain';

			mainObject.m_HttpComms.addValuePair('AUTH', 'Y2KE2GK2AGK010VX');
			mainObject.m_HttpComms.addValuePair('ACT', '/mail/Login');
			mainObject.m_HttpComms.addValuePair('SEQ', 'C');
			mainObject.m_HttpComms.addValuePair('SID', encodeURIComponent(mainObject.m_szSessionID) );
			mainObject.m_HttpComms.addValuePair('FLIST', 'timezone');
			mainObject.m_HttpComms.addValuePair('timezone', '-60');
			mainObject.m_HttpComms.addValuePair('userid', encodeURIComponent(mainObject.m_szUserName) );
			mainObject.m_HttpComms.addValuePair('password', encodeURIComponent(mainObject.m_szPassWord) );
			mainObject.m_HttpComms.addValuePair('style', 'default');
			mainObject.m_HttpComms.addValuePair('domain', 'tiscali.it');

			mainObject.m_HttpComms.setURI(szInboxURL);
			mainObject.m_HttpComms.setRequestMethod("POST");

			var bResult = mainObject.m_HttpComms.send(mainObject.loginOnloadHandler);
			if (!bResult) throw new Error("httpConnection returned false");
			mainObject.m_iStage++;
			break;

		case 1: // we need to find inbox URL
			var inboxURL = szResponse.match(PatternTiscaliInboxURL);
			if (inboxURL == null)
				throw new Error("error parsing Tiscali for inbox URL");

			// we're in
			mainObject.m_szMailboxURI = inboxURL[1];
			mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler - szMailBox: "+ inboxURL[1]);

			//server response
			mainObject.serverComms("+OK Your in\r\n");
			mainObject.m_bAuthorised = true;
			break;
		};

            mainObject.m_Log.Write("nsTiscali.js - loginOnloadHandler - END");
        }
        catch(err)
        {
            mainObject.m_Log.DebugDump("nsTiscali.js: loginHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);

            mainObject.serverComms("-ERR negative vibes\r\n");
        }
    },

    //stat
    //total size is in octets
    getNumMessages : function()
    {
        try
        {
            this.m_Log.Write("nsTiscali.js - getNumMessages - START"); 

		if (this.m_szMailboxURI == null) return false;

		var szMailboxURL = this.m_szMailURL + this.m_szMailboxURI  + '&allmsgs=1';

		this.m_Log.Write("nsTiscali.js - getNumMessages - mail box url " + szMailboxURL);

		this.m_iStage = 0;
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szMailboxURL);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.mailBoxOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

            this.m_Log.Write("nsTiscali.js - getNumMessages - END"); 
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsTiscali.js: getNumMessages : Exception : " 
                                          + e.name 
                                          + ".\nError message: " 
                                          + e.message);
            return false;
        }
    },

    mailBoxOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
            mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - START"); 

		mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler : " + mainObject.m_iStage);
		
		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);

		//check status should be 200.
		mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Mailbox :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);   

		mainObject.m_HttpComms.clean();

		//get message table
		var aMsgIDArray = szResponse.match(PatternTiscaliMsgIDStep1Table);
		mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - msgIDs :" + aMsgIDArray);

		if ( aMsgIDArray ) {
			var aMsgSizeArray = szResponse.match(PatternTiscaliMsgSizeStep1Table);
			mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - msgSizes :" + aMsgSizeArray);

			if ( aMsgSizeArray ) {
				if ( aMsgIDArray.lenght != aMsgSizeArray.lenght )
					throw new Error("nIDs != nSizes");

				var iNum = aMsgIDArray.length;
				mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - msgNum :" + iNum);

				for (i = 0; i <  iNum ; i++ ) {
					var anID = aMsgIDArray[i];
					var aSize = aMsgSizeArray[i];

					var aString = anID.match(PatternTiscaliMsgIDStep2Table);
					if ( aString ) {
						anID = aString[1];
						// mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Debug : MsgID=" + anID);
					} else 
						throw new Error("Error parsing MsgIDs");

					var aString = aSize.match(PatternTiscaliMsgSizeStep2Table);
					if ( aString ) {
						aSize = aString[1];
						var aString = aSize.match(PatternTiscaliMsgSizeStep3Table);
						if ( aString ) {
							aSize = aString[1];
							// mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Debug : non letto - " + aSize);
						} 
						/* else 
							mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Debug : Letto - " + aSize);
						*/
					} else 
						throw new Error("Error parsing MsgIDs");

					var data = new TiscaliMSG();

					data.szMsgID = anID;
					var fSize = parseFloat(aSize);
					if (aSize.indexOf('K')!= -1) fSize*=1000;
					iSize = Math.round(fSize);

					mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Debug :" + anID + " - " + iSize);

					data.iSize = iSize;
					mainObject.m_iTotalSize += iSize;
					mainObject.m_aMsgDataStore.push(data);
				}
			}

			mainObject.m_Log.Write("nsTiscali.js - mailBoxOnloadHandler - Debug : totalMsgNumber=" + mainObject.m_aMsgDataStore.length );
		} else {   //no emails
			// mainObject.serverComms("+OK "+ 0 + " " + 0 + "\r\n");
		}

		mainObject.serverComms("+OK "+ mainObject.m_aMsgDataStore.length + " " + mainObject.m_iTotalSize + "\r\n");

            mainObject.m_Log.Write("nsTiscali.js - MailBoxOnload - END"); 
        }
        catch(err)
        {
             mainObject.m_Log.DebugDump("nsTiscali.js: MailboxOnload : Exception : " 
                                              + err.name 
                                              + ".\nError message: " 
                                              + err.message);

             mainObject.serverComms("-ERR negative vibes\r\n");
        }
    },

    //list
    //I'm not downloading the mailbox again. 
    //I hope stat been called first or there's going to be trouble
    getMessageSizes : function() 
    {
	try
	{
		this.m_Log.Write("nsTiscali.js - getMessageSizes - START"); 

		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n"; 
		this.m_Log.Write("nsTiscali.js - getMessagesSizes - : " + this.m_aMsgDataStore.length);

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var iEmailSize = data.iSize;
			szPOPResponse+=(i+1) + " " + iEmailSize + "\r\n";
		}

		szPOPResponse += ".\r\n";

		this.serverComms(szPOPResponse);

		this.m_Log.Write("nsTiscali.js - getMessageSizes - END"); 
		return true;
	}
	catch(e)
	{
		this.m_Log.DebugDump("nsTiscali.js: getMessageSizes : Exception : " 
					+ e.name 
					+ ".\nError message: " 
					+ e.message);
		return false;
	}
    },

    //IUDL
    getMessageIDs : function()
    {
	try
	{
		this.m_Log.Write("nsTiscali.js - getMessageIDs - START");

		var szPOPResponse = "+OK " + this.m_aMsgDataStore.length + " Messages\r\n";
		this.m_Log.Write("nsTiscali.js - getMessageIDs - return : " + this.m_aMsgDataStore.length ); 

		for (i = 0; i <  this.m_aMsgDataStore.length; i++) {
			var data = this.m_aMsgDataStore[i];
			var szEmailID = data.szMsgID;
			szPOPResponse+=(i+1) + " " + szEmailID + "\r\n";
		}

		szPOPResponse += ".\r\n";
		this.serverComms(szPOPResponse);

		this.m_Log.Write("nsTiscali.js - getMessageIDs - END");
		return true;
	}
	catch(e)
	{
		this.m_Log.DebugDump("nsTiscali.js: getMessageIDs : Exception : "
                                          + e.name
                                          + ".\nError message: "
                                          + e.message);
		return false;
	}
    },

    //retr
    getMessage : function(msgIndex)
    {
        try
        {
		this.m_Log.Write("nsTiscali.js - getMessage - START"); 

		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsTiscali.js - getMessage - msg id: " + this.m_szMsgID); 

		var getMsgParams = "/mail/MessageDownload?sid=" + this.m_szSessionID + "&userid=" + this.m_szUserName + "&seq=+Q&auth=+A&srcfolder=INBOX&uid="+ this.m_szMsgID + "&AllHdrs=1&utf8=0&style=default"

		var szMsgURI = this.m_szMailURL + getMsgParams;

		//get message
		this.m_Log.Write("nsTiscali.js - getMessage - url: "+ szMsgURI);

		//get msg from Tiscali
		// this.m_iStage = 0;
		this.m_HttpComms.clean();
		this.m_HttpComms.setURI(szMsgURI);
		this.m_HttpComms.setRequestMethod("GET");
		var bResult = this.m_HttpComms.send(this.emailOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

		this.m_Log.Write("nsTiscali.js - getMessage - END"); 
		return true;
        }
        catch(e)
        {
             this.m_Log.DebugDump("nsTiscali.js: getMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        }
    },


    emailOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsTiscali.js - emailOnloadHandler - START");
		mainObject.m_Log.Write("nsTiscali.js - emailOnloadHandler - msg :\n" + szResponse); 

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		if (httpChannel.responseStatus != 200) 
			throw new Error("error status " + httpChannel.responseStatus);

		var szMsg =  "X-WebMail: true\r\n";
		szMsg += szResponse;

		szMsg += ".\r\n";  //msg end 

		var szPOPResponse = "+OK " + szMsg.length + "\r\n";
		szPOPResponse += szMsg;
		mainObject.serverComms(szPOPResponse);

		mainObject.m_Log.Write("nsTiscali.js - emailOnloadHandler - END");      
        }
        catch(err)
        {
		mainObject.m_Log.DebugDump("nsTiscali.js: emailOnloadHandler : Exception : " 
                                          + err.name 
                                          + ".\nError message: " 
                                          + err.message);
		mainObject.serverComms("-ERR negative vibes\r\n");
        }
    },

    //dele
    deleteMessage : function(msgIndex)
    {
        try
        {
            this.m_Log.Write("nsTiscali.js - deleteMessage - START");

		//get msg id
		var oMSGData = this.m_aMsgDataStore[msgIndex-1]
		this.m_szMsgID = oMSGData.szMsgID;
		this.m_Log.Write("nsTiscali.js - deleteMessage - msg id: " + this.m_szMsgID);

		var szDelPage = '/mail/MessageErase';
		var szDelMsgURL = this.m_szMailURL + szDelPage;

		this.m_HttpComms.clean();
		this.m_HttpComms.addValuePair('userid', encodeURIComponent(this.m_szUserName) );
		this.m_HttpComms.addValuePair('style', 'default');
		this.m_HttpComms.addValuePair('dstfolder', 'Trashcan');
		this.m_HttpComms.addValuePair('AUTH', '+A');
		this.m_HttpComms.addValuePair('ACT', '/mail/MessageMove');
		this.m_HttpComms.addValuePair('SEQ', '!LONG!');
		this.m_HttpComms.addValuePair('SID', this.m_szSessionID );
		this.m_HttpComms.addValuePair('srcfolder', 'INBOX');
		this.m_HttpComms.addValuePair('chk', '1');
		this.m_HttpComms.addValuePair('msguid', this.m_szMsgID );
		this.m_HttpComms.addValuePair('msgsubject', '' );

		//get message
		this.m_Log.Write("nsTiscali.js - deleteMessage - post url: "+ szDelMsgURL);

		//del msg from Tiscali
		this.m_HttpComms.setURI(szDelMsgURL);
		this.m_HttpComms.setRequestMethod("POST");
		var bResult = this.m_HttpComms.send(this.deleteMessageOnloadHandler); 
		if (!bResult) throw new Error("httpConnection returned false");

            this.m_Log.Write("nsTiscali.js - deleteMessage - END");
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsTiscali.js: deleteMessage : Exception : " 
                                          + e.name + 
                                          ".\nError message: " 
                                          + e.message);
            return false;
        } 
    },


    deleteMessageOnloadHandler : function (szResponse ,event , mainObject)
    {
        try
        {
		mainObject.m_Log.Write("nsTiscali.js - deleteMessageOnload - START");    

		var httpChannel = event.QueryInterface(Components.interfaces.nsIHttpChannel);
		//check status should be 200.
		mainObject.m_Log.Write("nsTiscali.js - deleteMessageOnload :" + httpChannel.responseStatus);
		if (httpChannel.responseStatus != 200 ) 
			throw new Error("error status " + httpChannel.responseStatus);   


		var szErrorMessage = szResponse.match(PatternTiscaliDeleteError);
		mainObject.m_Log.Write("nsTiscali.js - deleteMessageOnloadHandler - Debug :" + szErrorMessage);

		if ( szErrorMessage )
			throw new Error("Error deleting message... ");

		mainObject.serverComms("+OK its history\r\n");      
		mainObject.m_Log.Write("nsTiscali.js - deleteMessageOnload - END");      
        }
        catch(e)
        {
		mainObject.m_Log.DebugDump("nsTiscali.js: deleteMessageOnload : Exception : " + e.name
                                              + ".\nError message: " 
                                              + e.message);
		mainObject.serverComms("-ERR negative vibes\r\n");
        }
    },

    //cookies are deleted when the connection ends so i dont need to download pages
    logOut : function()
    {
        try
        {
            this.m_Log.Write("nsTiscali.js - logOUT - START"); 

            this.m_bAuthorised = false;
            this.serverComms("+OK Your Out\r\n");

            this.m_Log.Write("nsTiscali.js - logOUT - END");  
            return true;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsTiscali.js: logOUT : Exception : " 
                                      + e.name 
                                      + ".\nError message: " 
                                      + e.message);
            return false;
        }
    },  

    serverComms : function (szMsg)
    {
        try
        { 
            this.m_Log.Write("nsTiscali.js - serverComms - START");
            this.m_Log.Write("nsTiscali.js - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsTiscali.js - serverComms sent count: " + iCount +" msg length: " +szMsg.length);
            this.m_Log.Write("nsTiscali.js - serverComms - END");  
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsTiscali.js: serverComms : Exception : " 
                                              + e.name 
                                              + ".\nError message: " 
                                              + e.message);
        }
    },
   
   
/******************************************************************************/
/***************** XPCOM  stuff ***********************************************/
/******************************************************************************/
    QueryInterface : function (iid)
    {
        if (!iid.equals(Components.interfaces.nsIPOPDomainHandler) 
        	                      	&& !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
            
        return this;
    }
}
 

/******************************************************************************/
/* FACTORY*/
var nsTiscaliFactory = new Object();

nsTiscaliFactory.createInstance = function (outer, iid)
{
    if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
    
    if (!iid.equals(nsTiscaliClassID) && !iid.equals(Components.interfaces.nsISupports))
        throw Components.results.NS_ERROR_INVALID_ARG;
    
    return new nsTiscali();
}


/******************************************************************************/
/* MODULE */
var nsTiscaliModule = new Object();

nsTiscaliModule.registerSelf = function(compMgr, fileSpec, location, type)
{
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(nsTiscaliClassID,
                                    "TiscaliComponent",
                                    nsTiscaliContactID, 
                                    fileSpec,
                                    location, 
                                    type);
}


nsTiscaliModule.unregisterSelf = function(aCompMgr, aFileSpec, aLocation)
{
    aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(nsTiscaliClassID, aFileSpec);
}

 
nsTiscaliModule.getClassObject = function(compMgr, cid, iid)
{
    if (!cid.equals(nsTiscaliClassID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return nsTiscaliFactory;
}


nsTiscaliModule.canUnload = function(compMgr)
{
    return true;
}
/******************************************************************************/


function NSGetModule(compMgr, fileSpec)
{
    return nsTiscaliModule; 
}
